
.enum	@dmactl
	blank	= %00
	narrow	= %01
	standard= %10
	wide	= %11
	missiles= %100
	players	= %1000
	lineX1	= %10000
	lineX2	= %00000
	dma	= %100000
.ende

scr48	= @dmactl(wide|dma|players|missiles|lineX1)		;screen 48b
scr40	= @dmactl(standard|dma|players|missiles|lineX1)		;screen 40b
scr32	= @dmactl(narrow|dma|players|missiles|lineX1)		;screen 32b

.enum	@pmcntl
	missiles= %1
	players	= %10
	trigs	= %100
.ende

.enum	@gtictl
	prior0	= %0
	prior1	= %1
	prior2	= %10
	prior4	= %100
	prior8	= %1000
	ply5	= %10000	; Fifth Player Enable
	mlc	= %100000	; Multiple Color Player Enable
	mode9	= %01000000
	mode10	= %10000000
	mode11	= %11000000
.ende


* ---------------------------------------------------------------------------------------------
* ---	OS
* ---------------------------------------------------------------------------------------------

lmargin	= $52
rmargin	= $53
rowcrs	= $54
colcrs	= $55

* ---------------------------------------------------------------------------------------------
* ---	KEY ($d209)
* ---------------------------------------------------------------------------------------------
key_esc		= 28
key_space	= 33
key_v		= 16
key_b		= 21
key_n		= 35
key_m		= 37

* ---------------------------------------------------------------------------------------------
* ---	GTIA
* ---------------------------------------------------------------------------------------------
hposp0	=	$D000		; pozioma pozycja gracza 0 (Z)
hposp1	=	$D001		; pozioma pozycja gracza 1 (Z)
hposp2	=	$D002		; pozioma pozycja gracza 2 (Z)
hposp3	=	$D003		; pozioma pozycja gracza 3 (Z)
hposm0	=	$D004		; pozioma pozycja pocisku 0 (Z)
hposm1	=	$D005		; pozioma pozycja pocisku 1 (Z)
hposm2	=	$D006		; pozioma pozycja pocisku 2 (Z)
hposm3	=	$D007		; pozioma pozycja pocisku 3 (Z)
sizep0	=	$D008		; poziomy rozmiar gracza 0 (Z)
sizep1	=	$D009		; poziomy rozmiar gracza 1 (Z)
sizep2	=	$D00A		; poziomy rozmiar gracza 2 (Z)
sizep3	=	$D00B		; poziomy rozmiar gracza 3 (Z)
sizem	=	$D00C		; poziomy rozmiar pociskw (Z)
grafp0	=	$D00D		; rejestr grafiki gracza 0 (Z)
grafp1	=	$D00E		; rejestr grafiki gracza 1 (Z)
grafp2	=	$D00F		; rejestr grafiki gracza 2 (Z)
grafp3	=	$D010		; rejestr grafiki gracza 3 (Z)
grafm	=	$D011		; rejestr grafiki pociskw (Z)
colpm0	=	$D012		; rejestr koloru gracza i pocisku 0 (Z)
colpm1	=	$D013		; rejestr koloru gracza i pocisku 1 (Z)
colpm2	=	$D014		; rejestr koloru gracza i pocisku 2 (Z)
colpm3	=	$D015		; rejestr koloru gracza i pocisku 3 (Z)
colpf0	=	$D016		; rejestr koloru pola gry 0 (Z)
colpf1	=	$D017		; rejestr koloru pola gry 1 (Z)
colpf2	=	$D018		; rejestr koloru pola gry 2 (Z)
colpf3	=	$D019		; rejestr koloru pola gry 3 (Z)
colbak	=	$D01A		; rejestr koloru ta (Z)

color0	=	colpf0
color1	=	colpf1
color2	=	colpf2
color3	=	colpf3

kolm0pf	=	$D000		; kolizja pocisku 0 z polem gry (O)
kolm1pf	=	$D001		; kolizja pocisku 1 z polem gry (O)
kolm2pf	=	$D002		; kolizja pocisku 2 z polem gry (O)
kolm3pf	=	$D003		; kolizja pocisku 3 z polem gry (O)
kolp0pf	=	$D004		; kolizja gracza 0 z polem gry (O)
kolp1pf	=	$D005		; kolizja gracza 1 z polem gry (O)
kolp2pf	=	$D006		; kolizja gracza 2 z polem gry (O)
kolp3pf	=	$D007		; kolizja gracza 3 z polem gry (O)
kolm0p	=	$D008		; kolizja pocisku 0 z graczem (O)
kolm1p	=	$D009		; kolizja pocisku 1 z graczem (O)
kolm2p	=	$D00A		; kolizja pocisku 2 z graczem (O)
kolm3p	=	$D00B		; kolizja pocisku 3 z graczem (O)
kolp0p	=	$D00C		; kolizja gracza 0 z innym graczem (O)
kolp1p	=	$D00D		; kolizja gracza 1 z innym graczem (O)
kolp2p	=	$D00E		; kolizja gracza 2 z innym graczem (O)
kolp3p	=	$D00F		; kolizja gracza 3 z innym graczem (O)
trig0	=	$D010		; stan przycisku joysticka 0 (O)
trig1	=	$D011		; stan przycisku joysticka 1 (O)
trig3	=	$D013		; znacznik doczenia cartridge-a (O)
pal	=	$D014		; znacznik systemu TV (O)

gtictl	=	$D01B		; rejestr kontroli ukadu GTIA
gtiactl	=	gtictl

vdelay	=	$D01C		; licznik opnienia pionowego P/MG
pmcntl	=	$D01D		; rejestr kontroli graczy i pociskw
hitclr	=	$D01E		; rejestr kasowania rejestrw kolizji
consol	=	$D01F		; rejestr stanu klawiszy konsoli

* ---------------------------------------------------------------------------------------------
* ---	POKEY
* ---------------------------------------------------------------------------------------------

irqens	=	$0010		; rejestr-cie IRQEN
irqstat	=	$0011		; rejestr-cie IRQST

audf1	=	$d200		; czstotliwo pracy generatora 1 (Z)
audc1	=	$d201		; rejestr kontroli dwiku generatora 1 (Z)
audf2	=	$d202		; czstotliwo pracy generatora 2 (Z)
audc2	=	$d203		; rejestr kontroli dwiku generatora 2 (Z)
audf3	=	$d204		; czstotliwo pracy generatora 3 (Z)
audc3	=	$d205		; rejestr kontroli dwiku generatora 3 (Z)
audf4	=	$d206		; czstotliwo pracy generatora 4 (Z)
audc4	=	$d207		; rejestr kontroli dwiku generatora 4 (Z)

audctl	=	$D208		; rejestr kontroli generatorw dwiku (Z)
stimer	=	$D209		; rejestr zerowania licznikw (Z)
kbcode	=	$D209		; kod ostatnio nacinitego klawisza (O)
skstres	=	$D20A		; rejestr statusu zcza szeregowego (Z)
random	=	$D20A		; rejestr liczby losowej (O)
serout	=	$D20D		; szeregowy rejestr wyjciowy (Z)
serin	=	$D20D		; szeregowy rejestr wejciowy (O)
irqen	=	$D20E		; zezwolenie przerwa IRQ (Z)
irqst	=	$D20E		; status przerwa IRQ (O)
skctl	=	$D20F		; rejestr kontroli zcza szeregowego (Z)
skstat	=	$D20F		; rejestr statusu zcza szeregowego (O)

* ---------------------------------------------------------------------------------------------
* ---	PIA
* ---------------------------------------------------------------------------------------------
porta	=	$D300		; port A ukadu PIA
portb	=	$D301		; port B ukadu PIA
pactl	=	$D302		; rejestr kontroli portu A
pbctl	=	$D303		; rejestr kontroli portu B

* ---------------------------------------------------------------------------------------------
* ---	ANTIC
* ---------------------------------------------------------------------------------------------
dmactl	=	$D400		; rejestr kontroli dostpu do pamici
chrctl	=	$D401		; rejestr kontroli wywietlania znakw
dlptr	=	$D402		; adres programu ANTIC-a
hscrol	=	$D404		; znacznik poziomego przesuwu obrazu
vscrol	=	$D405		; znacznik pionowego przesuwu obrazu
pmbase	=	$D407		; adres pamici graczy i pociskw
chbase	=	$D409		; adres zestawu znakw
wsync	=	$D40A		; znacznik oczekiwania na synchronizacj poziom
vcount	=	$D40B		; licznik linii obrazu
lpenh	=	$D40C		; poziome pooenie pira wietlengo
lpenv	=	$D40D		; pionowe pooenie pira wietlnego
nmien	=	$D40E		; rejestr zezwole na przerwania NMI
nmist	=	$D40F		; rejestr statusu przerwa NMI

* ---------------------------------------------------------------------------------------------
* ---	OS
* ---------------------------------------------------------------------------------------------

colpf0s	=	$02C4		; rejestr-cie COLPF0
colpf1s	=	$02C5		; rejestr-cie COLPF1
colpf2s	=	$02C6		; rejestr-cie COLPF2
colpf3s	=	$02C7		; rejestr-cie COLPF3
colbaks	=	$02C8		; rejestr-cie COLBAK
